<template>
  <DefaultLayout>
    <!--No Installer-->
    <div v-if="$page.device.noInstall" class="banner-grey no-installer py-4">
      <p class="h6">
        <a v-if="$page.device.installLink" :href="$page.device.installLink"
          >This device hasn’t been added to the UBports Installer yet. Click
          here to find installation instructions.</a
        >
        <span v-else-if="$page.device.enableMdRendering"
          >This device hasn’t been added to the UBports Installer yet.
        </span>
        <span v-else
          >This device hasn’t been added to the UBports Installer yet.
          Installation instructions <b>not available</b> at the moment.</span
        >
      </p>
    </div>

    <!-- Heading -->
    <div id="deviceOverview" class="heading mt-lg-5">
      <!-- Title -->
      <a
        :href="
          'https://devices.ubuntu-touch.io/device/' +
          $page.device.codename +
          '/'
        "
        :title="$page.device.name + ' can be a Linux phone'"
      >
        <h1 class="h3">{{ $page.device.name }}</h1>
      </a>
    </div>

    <!-- Tags -->
    <div class="meta">
      <span v-if="$page.device.portType" class="badge badge-primary">
        <a href="#docLinks">
          {{ $page.device.portType }}
        </a>
      </span>

      <span class="badge badge-primary">
        <g-link to="/about/codenames">
          {{ $page.device.codename }}
        </g-link>
      </span>

      <span v-if="!$page.device.noInstall" class="badge badge-primary">
        <g-link to="/installer"> Installer </g-link>
      </span>

      <span
        v-if="$page.device.isConvergenceEnabled"
        class="badge badge-primary"
      >
        <a
          href="https://docs.ubports.com/en/latest/humanguide/other-design-considerations/convergence.html"
          target="_blank"
        >
          Convergence
        </a>
      </span>

      <span v-if="!$page.device.disableBuyLink" class="badge badge-primary">
        <a
          :href="
            $page.device.buyLink
              ? $page.device.buyLink
              : 'https://swappa.com/search?q=' + $page.device.name
          "
          target="_blank"
        >
          Buy <span v-if="$page.device.price">~{{ $page.device.price }}$</span>
        </a>
      </span>
    </div>

    <!--Description-->
    <div class="mb-5 mt-5">
      <div>
        <!--Progress-->
        <p class="small mb-2 light">
          <span class="bold">{{ $page.device.progressStage.name }} </span>

          <span v-if="$page.device.nextProgressStage">
            <span
              id="device-next-stage-help"
              class="badge progress-badge ml-2 normal-size"
            >
              State: {{ $page.device.progressAdvancement }}
            </span>
            <b-popover
              target="device-next-stage-help"
              triggers="click blur"
              placement="bottomright"
            >
              <span>
                This rating shows whether or not a device has received updates
                recently, if so, it has a good chance to be maintained in the
                future, but that's not guaranteed.
              </span>
              <br /><br />

              <span class="bold"
                >Q: What does this port need to get better?</span
              >
              <br /><br />

              A: Complete the following features:
              <br /><br />
              <ul>
                <li
                  v-for="(missingFeature, index) in $page.device
                    .nextStageRequirements"
                  :key="index"
                >
                  - <span class="text-orange small">{{ missingFeature }}</span>
                </li>
              </ul>
            </b-popover>
          </span>
        </p>
        <div class="progress">
          <div
            class="progress-bar"
            role="progressbar"
            :style="{ width: $page.device.progress + '%' }"
            :aria-valuenow="$page.device.progress"
            aria-valuemin="0"
            aria-valuemax="1"
          ></div>
        </div>
      </div>

      <div class="row">
        <div class="col-lg-12">
          <p v-if="$page.device.description" class="small mb-2 mt-4 light">
            Description
          </p>
          <p class="col-mb-2">{{ $page.device.description }}</p>
        </div>
      </div>
    </div>

    <!-- Unmaintained -->
    <div
      v-if="$page.device.tag == 'unmaintained'"
      class="banner-grey unmaintained bold py-4"
    >
      <p>
        This device is not maintained, nobody is actively developing it and it
        will not receive fixes for known issues.
      </p>
      <p>
        If you are a developer we encourage you to contact the porter to
        continue development.
      </p>
    </div>

    <!-- TODO: 20.04 drop warning (enable for Halium 5.1 and Legacy when ready) -->
    <div v-if="false" class="banner-grey unmaintained py-4">
      <h4 class="mb-2">This device might be dropped soon</h4>
      <p>
        This device might <span class="bold">cease to get OTA updates</span> and
        security updates contained in them when Ubuntu Touch is updated to the
        Ubuntu 20.04 base.
      </p>
    </div>

    <PortStatus
      v-if="$page.device.portStatus.length"
      id="portStatus"
      :port-status="$page.device.portStatus"
      :progress-stage="$page.device.progressStage.description"
      :untested-count="$page.device.untestedCount"
      class="mt-5"
    />

    <div
      v-if="$page.device.untestedCount > 0"
      id="helpWanted"
      class="banner-grey d-print-none"
    >
      <div class="row">
        <div class="col-lg-8 col-sm-12">
          <p>Do you own this device and can help with testing?</p>
          <h3 class="h3 light">
            The <span class="strong">{{ $page.device.name }}</span> still has
            <span class="text-orange bold underline">{{
              $page.device.untestedCount
            }}</span>
            unverified features.
          </h3>
          <p v-b-toggle.discussionsbar class="mt-4">
            → Please contact
            <span
              v-if="$page.device.contributors.length"
              class="text-orange underline"
            >
              {{ $page.device.contributors[0].name }}</span
            ><span v-else>the porter</span>, they need your help.
          </p>
        </div>
        <div class="phones-container">
          <g-image class="test" src="~/assets/img/tilted-device.svg" />
        </div>
      </div>
    </div>

    <div
      v-else-if="!$page.device.noInstall && $page.device.progress > 95"
      id="helpWanted"
      class="banner-grey mt-5"
    >
      <div class="phones-container">
        <g-image class="test" src="~/assets/img/test.svg" />
      </div>

      <div class="col-lg-10 col-sm-12 support-device d-print-none">
        <div class="row">
          <h3 class="h4">Support with casual testing</h3>
          <p class="mt-4">
            Some things are just so important that they need to be tested every
            day, every week, every month. Just hang around in
            <a
              class="underline text-orange"
              target="_blank"
              href="https://t.me/ubports_qa_team"
              >QA group</a
            >
            and try out the stuff that gets flagged. Without your help the
            developers may sit there for days more, trying to figure out the
            puzzle.
          </p>
          <p class="mt-2">
            Join and introduce yourself
            <span class="bold"
              >“Hi, my name is X, and I own Z. How can I help?”</span
            >
            that will do fine ;)
          </p>

          <p class="mt-2">
            Unless you want to step up to become our
            <a
              href="https://ubports.com/blog/ubports-news-1/post/we-need-you-to-help-test-our-releases-3781"
              target="_blank"
              class="underline"
              >Test Manager</a
            >, but that is a whole different story.
          </p>
        </div>
      </div>
    </div>

    <ReleaseChannels
      v-if="$page.device.releaseChannels.length"
      id="releaseChannels"
      :release-channels="$page.device.releaseChannels"
    />

    <DeviceInfo
      v-if="$page.device.deviceInfo.length"
      id="deviceSpec"
      :device-info="$page.device.deviceInfo"
      class="mt-5"
    />

    <div
      v-if="$page.device.enableMdRendering"
      class="markdown-content mt-5"
      v-html="$page.device.content"
    ></div>

    <!-- Docs -->
    <div
      v-if="$page.device.portType || $page.device.docLinks.length"
      id="docLinks"
      class="row no-gutters mt-5"
    >
      <div v-if="$page.device.portType" class="col-md-12 col-lg-5 related">
        <h2 class="title bold mb-3">Built on {{ $page.device.portType }}</h2>
        <p>{{ $page.device.portTypeDescription }}</p>
        <p class="mt-4 d-print-none">
          →
          <a
            href="https://docs.ubports.com/en/latest/porting/introduction/Intro.html"
            >Learn more</a
          >
        </p>
      </div>

      <div
        v-if="$page.device.docLinks.length"
        class="col-md-6 offset-lg-1 mt-5 mt-lg-0 related d-print-none"
      >
        <h2 class="title bold mb-3">Docs</h2>
        <ul>
          <li v-for="link in $page.device.docLinks" :key="link.name">
            <p>
              → <a :href="link.link">{{ link.name }}</a>
            </p>
          </li>
        </ul>
      </div>
    </div>

    <!-- Contributors & Discussions -->
    <div
      v-if="
        $page.device.contributors.length || $page.device.externalLinks.length
      "
      id="portContributors"
      class="contributors-discussions d-print-none"
    >
      <!-- Discussions -->
      <div v-if="$page.device.externalLinks.length" class="discussions">
        <h2 class="mt-5 mb-3 h3">Port Resources</h2>
        <ul>
          <!-- Link -->
          <li v-for="link in $page.device.externalLinks" :key="link.name">
            <a :href="link.link">
              <g-image
                :src="
                  require(`!!assets-loader!@/assets/img/services/${link.icon}.svg`)
                "
                alt="link-icon"
                class="dark-invert-40 ext-link-icon"
              />
              {{ link.name }}
            </a>
          </li>
        </ul>
      </div>

      <!-- Contributors -->
      <div v-if="$page.device.contributors.length" class="contributors">
        <h2 class="mt-5 mb-3 h3">Maintainers</h2>
        <ul>
          <!-- Person -->
          <li v-for="person in $page.device.contributors" :key="person.name">
            <a :href="person.forum">
              <g-image
                v-if="person.photo"
                :src="require(`!!assets-loader!@/${person.photo}`)"
                alt="person-img"
              />
              <g-image v-else src="~/assets/img/yumi3d.jpg" alt="person-img" />
              <p>{{ person.name }}</p>
            </a>
          </li>
        </ul>
      </div>
    </div>

    <InstallerBanner v-if="!$page.device.noInstall" id="installerDownload" />

    <!-- Read more -->
    <div
      v-if="
        !$page.device.noInstall &&
        $page.device.untestedCount == 0 &&
        $page.device.progress > 95
      "
      class="banner-purple d-print-none"
    >
      <div class="container-fluid row">
        <div class="col-lg-6 col-sm-6 mb-5 d-flex flex-column">
          <p class="underline">Help Needed</p>
          <h2 class="h3 light">Test the latest OTA's release</h2>
          <p class="mt-5">
            <a
              href="https://ubports.com/blog/ubports-news-1/post/we-need-you-to-help-test-our-releases-3781"
              target="_blank"
              >→ <b>UBports Blog</b></a
            >
          </p>
        </div>

        <div class="col-lg-6 col-sm-6 mb-5 d-flex flex-column">
          <p class="underline">User Guide</p>
          <h2 class="h3 light">Ubuntu Touch Manual</h2>
          <p class="mt-5">
            <a
              href="https://docs.ubports.com/en/latest/userguide/dailyuse/index.html"
              target="_blank"
              >→ <b>UBports Docs</b></a
            >
          </p>
        </div>
      </div>
    </div>

    <NavMenu :available-data="availableData" />
    <FlagIssue
      :device-name="$page.device.name"
      :device-codename="$page.device.codename"
    />
    <DiscussionsBar
      :device-name="$page.device.name"
      :developer-report="$page.device.path"
      :invalid-prop-count="$page.device.notValid.length"
      :community-links="$page.device.communityHelp"
      :forum-topics="$page.device.forumTopics"
      :subforum-link="
        'https://forums.ubports.com/category/' + $page.device.subforum
      "
    />
  </DefaultLayout>
</template>

<page-query>
query ($id: ID!) {
  device(id: $id) {
    name
    codename
    path(to:"developer")
    portType
    portTypeDescription
    deviceType
    progress
    progressStage { name description }
    nextProgressStage { name }
    nextStageRequirements
    progressAdvancement
    noInstall
    installLink
    buyLink
    disableBuyLink
    price
    description
    tag
    isConvergenceEnabled
    enableMdRendering
    subforum
    content
    notValid
    untestedCount
    portStatus {
      categoryName
      features { name value bugTracker global }
    }
    releaseChannels {
      ubuntuRelease channel version releaseDate(format: "DD-MM-YYYY") description
    }
    deviceInfo {
      name value
    }
    contributors {
      name photo forum
    }
    communityHelp {
      name link icon
    }
    externalLinks {
      name link icon
    }
    docLinks {
      name link
    }
    forumTopics {
      title user timestamp views link locked pinned
    }
    seo { description keywords }
  }
}
</page-query>

<script>
import PortStatus from "~/components/devices/PortStatus.vue";
import DeviceInfo from "~/components/devices/DeviceInfo.vue";
import ReleaseChannels from "~/components/devices/ReleaseChannels.vue";
import InstallerBanner from "~/components/devices/InstallerBanner.vue";

import FlagIssue from "~/components/devices/FlagIssue.vue";
import DiscussionsBar from "~/components/devices/DiscussionsBar.vue";

import NavMenu from "~/components/devices/NavMenu.vue";

import { VBToggle, BPopover } from "bootstrap-vue";

export default {
  metaInfo() {
    return {
      title: this.$page.device.name,
      meta: [
        {
          name: "keywords",
          content: this.$page.device.seo
            ? this.$page.device.seo.keywords
            : "Ubuntu Touch, " +
              this.$page.device.name +
              ", Privacy phone, Linux smartphone, Linux on mobile"
        },
        {
          name: "description",
          content: this.$page.device.seo
            ? this.$page.device.seo.description
            : "Flash your " +
              this.$page.device.name +
              " with the latest version of the Ubuntu Touch operating system, a privacy focused OS developed by hundreds of people."
        },
        {
          property: "og:url",
          content: "https://devices.ubuntu-touch.io" + this.$route.path
        },
        {
          property: "og:title",
          content: this.$page.device.name + " • Ubuntu Touch • Linux Phone"
        },
        {
          property: "og:description",
          content: this.$page.device.seo
            ? this.$page.device.seo.description
            : "Flash your " +
              this.$page.device.name +
              " with the latest version of the Ubuntu Touch operating system, a privacy focused OS developed by hundreds of people."
        }
      ]
    };
  },
  components: {
    BPopover,
    DiscussionsBar,
    FlagIssue,
    NavMenu,
    PortStatus,
    DeviceInfo,
    ReleaseChannels,
    InstallerBanner
  },
  directives: {
    "b-toggle": VBToggle
  },
  computed: {
    availableData: function () {
      return {
        portStatus: this.$page.device.portStatus.length > 0,
        deviceSpec: this.$page.device.deviceInfo.length > 0,
        helpWanted:
          this.$page.device.untestedCount > 0 ||
          (!this.$page.device.noInstall && this.$page.device.progress > 95),
        docLinks: this.$page.device.docLinks.length > 0,
        portContributors: this.$page.device.contributors.length > 0,
        installerDownload: !this.$page.device.noInstall,
        discussionsbar:
          this.$page.device.forumTopics.length > 0 ||
          this.$page.device.communityHelp.length > 0 ||
          this.$page.device.notValid.length > 0
      };
    }
  }
};
</script>
